<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>thunar-util: Thunar Internal Functions Reference Manual</title>
<meta name="generator" content="DocBook XSL Stylesheets Vsnapshot">
<link rel="home" href="index.html" title="Thunar Internal Functions Reference Manual">
<link rel="up" href="ch05.html" title="Miscellaneous">
<link rel="prev" href="ch05.html" title="Miscellaneous">
<link rel="next" href="thunar-thunar-enum-types.html" title="thunar-enum-types">
<meta name="generator" content="GTK-Doc V1.34.0 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="5"><tr valign="middle">
<td width="100%" align="left" class="shortcuts">
<a href="#" class="shortcut">Top</a><span id="nav_description">  <span class="dim">|</span> 
                  <a href="#thunar-thunar-util.description" class="shortcut">Description</a></span>
</td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="16" height="16" border="0" alt="Home"></a></td>
<td><a accesskey="u" href="ch05.html"><img src="up.png" width="16" height="16" border="0" alt="Up"></a></td>
<td><a accesskey="p" href="ch05.html"><img src="left.png" width="16" height="16" border="0" alt="Prev"></a></td>
<td><a accesskey="n" href="thunar-thunar-enum-types.html"><img src="right.png" width="16" height="16" border="0" alt="Next"></a></td>
</tr></table>
<div class="refentry">
<a name="thunar-thunar-util"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="thunar-thunar-util.top_of_page"></a>thunar-util</span></h2>
<p>thunar-util</p>
</td>
<td class="gallery_image" valign="top" align="right"></td>
</tr></table></div>
<div class="refsect1">
<a name="thunar-thunar-util.functions"></a><h2>Functions</h2>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="functions_proto_type">
<col class="functions_proto_name">
</colgroup>
<tbody>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<span class="c_punctuation">(</span><a class="link" href="thunar-thunar-util.html#ThunarBookmarksFunc" title="ThunarBookmarksFunc ()">*ThunarBookmarksFunc</a><span class="c_punctuation">)</span> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-str-get-extension" title="thunar_util_str_get_extension ()">thunar_util_str_get_extension</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-load-bookmarks" title="thunar_util_load_bookmarks ()">thunar_util_load_bookmarks</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gboolean</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-looks-like-an-uri" title="thunar_util_looks_like_an_uri ()">thunar_util_looks_like_an_uri</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-expand-filename" title="thunar_util_expand_filename ()">thunar_util_expand_filename</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">guint64</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-get-file-time" title="thunar_util_get_file_time ()">thunar_util_get_file_time</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-humanize-file-time" title="thunar_util_humanize_file_time ()">thunar_util_humanize_file_time</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">GdkScreen</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-parse-parent" title="thunar_util_parse_parent ()">thunar_util_parse_parent</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">time_t</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-time-from-rfc3339" title="thunar_util_time_from_rfc3339 ()">thunar_util_time_from_rfc3339</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-change-working-directory" title="thunar_util_change_working_directory ()">thunar_util_change_working_directory</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-setup-display-cb" title="thunar_setup_display_cb ()">thunar_setup_display_cb</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-next-new-file-name" title="thunar_util_next_new_file_name ()">thunar_util_next_new_file_name</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-next-new-file-name-raw" title="thunar_util_next_new_file_name_raw ()">thunar_util_next_new_file_name_raw</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">const <span class="returnvalue">char</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-get-search-prefix" title="thunar_util_get_search_prefix ()">thunar_util_get_search_prefix</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gboolean</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-is-a-search-query" title="thunar_util_is_a_search_query ()">thunar_util_is_a_search_query</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-strjoin-list" title="thunar_util_strjoin_list ()">thunar_util_strjoin_list</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">void</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-clip-view-background" title="thunar_util_clip_view_background ()">thunar_util_clip_view_background</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> **
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-split-search-query" title="thunar_util_split_search_query ()">thunar_util_split_search_query</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gboolean</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-search-terms-match" title="thunar_util_search_terms_match ()">thunar_util_search_terms_match</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gboolean</span>
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-save-geometry-timer" title="thunar_util_save_geometry_timer ()">thunar_util_save_geometry_timer</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-get-statusbar-text-for-files" title="thunar_util_get_statusbar_text_for_files ()">thunar_util_get_statusbar_text_for_files</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-get-statusbar-text-for-single-file" title="thunar_util_get_statusbar_text_for_single_file ()">thunar_util_get_statusbar_text_for_single_file</a> <span class="c_punctuation">()</span>
</td>
</tr>
<tr>
<td class="function_type">
<span class="returnvalue">gchar</span> *
</td>
<td class="function_name">
<a class="link" href="thunar-thunar-util.html#thunar-util-accel-path-to-id" title="thunar_util_accel_path_to_id ()">thunar_util_accel_path_to_id</a> <span class="c_punctuation">()</span>
</td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect1">
<a name="thunar-thunar-util.other"></a><h2>Types and Values</h2>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="other_proto_type">
<col class="other_proto_name">
</colgroup>
<tbody>
<tr>
<td class="define_keyword">#define</td>
<td class="function_name"><a class="link" href="thunar-thunar-util.html#ALPHA-BACKDROP:CAPS" title="ALPHA_BACKDROP">ALPHA_BACKDROP</a></td>
</tr>
<tr>
<td class="define_keyword">#define</td>
<td class="function_name"><a class="link" href="thunar-thunar-util.html#ALPHA-FOCUSED:CAPS" title="ALPHA_FOCUSED">ALPHA_FOCUSED</a></td>
</tr>
<tr>
<td class="define_keyword">#define</td>
<td class="function_name"><a class="link" href="thunar-thunar-util.html#STACK-ALLOC-LIMIT:CAPS" title="STACK_ALLOC_LIMIT">STACK_ALLOC_LIMIT</a></td>
</tr>
<tr>
<td class="define_keyword">#define</td>
<td class="function_name"><a class="link" href="thunar-thunar-util.html#MAX-EMBLEMS-PER-FILE:CAPS" title="MAX_EMBLEMS_PER_FILE">MAX_EMBLEMS_PER_FILE</a></td>
</tr>
<tr>
<td class="datatype_keyword">enum</td>
<td class="function_name"><a class="link" href="thunar-thunar-util.html#ThunarNextFileNameMode" title="enum ThunarNextFileNameMode">ThunarNextFileNameMode</a></td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect1">
<a name="thunar-thunar-util.description"></a><h2>Description</h2>
</div>
<div class="refsect1">
<a name="thunar-thunar-util.functions_details"></a><h2>Functions</h2>
<div class="refsect2">
<a name="ThunarBookmarksFunc"></a><h3>ThunarBookmarksFunc ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
<span class="c_punctuation">(</span>*ThunarBookmarksFunc<span class="c_punctuation">)</span> (<em class="parameter"><code><span class="type">GFile</span> *file</code></em>,
                        <em class="parameter"><code>const <span class="type">gchar</span> *name</code></em>,
                        <em class="parameter"><code><span class="type">gint</span> row_num</code></em>,
                        <em class="parameter"><code><span class="type">gpointer</span> user_data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-str-get-extension"></a><h3>thunar_util_str_get_extension ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_str_get_extension (<em class="parameter"><code>const <span class="type">gchar</span> *name</code></em>);</pre>
<p>Returns a pointer to the extension in <em class="parameter"><code>filename</code></em>
.</p>
<p>This is an improved version of g_utf8_strrchr with
improvements to recognize compound extensions like
".tar.gz" and ".desktop.in.in".</p>
<div class="refsect3">
<a name="thunar-util-str-get-extension.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>filename</p></td>
<td class="parameter_description"><p>an UTF-8 filename</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-str-get-extension.returns"></a><h4>Returns</h4>
<p> pointer to the extension in <em class="parameter"><code>filename</code></em>
or NULL.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-load-bookmarks"></a><h3>thunar_util_load_bookmarks ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
thunar_util_load_bookmarks (<em class="parameter"><code><span class="type">GFile</span> *bookmarks_file</code></em>,
                            <em class="parameter"><code><a class="link" href="thunar-thunar-util.html#ThunarBookmarksFunc" title="ThunarBookmarksFunc ()"><span class="type">ThunarBookmarksFunc</span></a> foreach_func</code></em>,
                            <em class="parameter"><code><span class="type">gpointer</span> user_data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-looks-like-an-uri"></a><h3>thunar_util_looks_like_an_uri ()</h3>
<pre class="programlisting"><span class="returnvalue">gboolean</span>
thunar_util_looks_like_an_uri (<em class="parameter"><code>const <span class="type">gchar</span> *string</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-expand-filename"></a><h3>thunar_util_expand_filename ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_expand_filename (<em class="parameter"><code>const <span class="type">gchar</span> *filename</code></em>,
                             <em class="parameter"><code><span class="type">GFile</span> *working_directory</code></em>,
                             <em class="parameter"><code><span class="type">GError</span> **error</code></em>);</pre>
<p>Takes a user-typed <em class="parameter"><code>filename</code></em>
 and expands a tilde at the
beginning of the <em class="parameter"><code>filename</code></em>
. It also resolves paths prefixed with
'.' using the current working directory.</p>
<p>The caller is responsible to free the returned string using
<code class="function">g_free()</code> when no longer needed.</p>
<div class="refsect3">
<a name="thunar-util-expand-filename.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>filename</p></td>
<td class="parameter_description"><p>a local filename.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>working_directory</p></td>
<td class="parameter_description"><p><span class="type">GFile</span> of the current working directory.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>error</p></td>
<td class="parameter_description"><p>return location for errors or <code class="literal">NULL</code>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-expand-filename.returns"></a><h4>Returns</h4>
<p> the expanded <em class="parameter"><code>filename</code></em>
or <code class="literal">NULL</code> on error.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-get-file-time"></a><h3>thunar_util_get_file_time ()</h3>
<pre class="programlisting"><span class="returnvalue">guint64</span>
thunar_util_get_file_time (<em class="parameter"><code><span class="type">GFileInfo</span> *file_info</code></em>,
                           <em class="parameter"><code><a class="link" href="ThunarFile.html#ThunarFileDateType" title="enum ThunarFileDateType"><span class="type">ThunarFileDateType</span></a> date_type</code></em>);</pre>
<p>Queries the given <em class="parameter"><code>date_type</code></em>
 from <em class="parameter"><code>file_info</code></em>
 and returns the result.</p>
<div class="refsect3">
<a name="thunar-util-get-file-time.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>file_info</p></td>
<td class="parameter_description"><p>a <span class="type">GFileInfo</span> instance.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>date_type</p></td>
<td class="parameter_description"><p>the kind of date you are interested in.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-get-file-time.returns"></a><h4>Returns</h4>
<p> the time for <em class="parameter"><code>file_info</code></em>
of the given <em class="parameter"><code>date_type</code></em>
.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-humanize-file-time"></a><h3>thunar_util_humanize_file_time ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_humanize_file_time (<em class="parameter"><code><span class="type">guint64</span> file_time</code></em>,
                                <em class="parameter"><code><a class="link" href="thunar-thunar-enum-types.html#ThunarDateStyle" title="enum ThunarDateStyle"><span class="type">ThunarDateStyle</span></a> date_style</code></em>,
                                <em class="parameter"><code>const <span class="type">gchar</span> *date_custom_style</code></em>);</pre>
<p>Returns a human readable date representation of the specified
<em class="parameter"><code>file_time</code></em>
. The caller is responsible to free the returned
string using <code class="function">g_free()</code> when no longer needed.</p>
<div class="refsect3">
<a name="thunar-util-humanize-file-time.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>file_time</p></td>
<td class="parameter_description"><p>a <span class="type">guint64</span> timestamp.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>date_style</p></td>
<td class="parameter_description"><p>the <span class="type">ThunarDateFormat</span> used to humanize the <em class="parameter"><code>file_time</code></em>
.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>date_custom_style</p></td>
<td class="parameter_description"><p>custom style to apply, if <em class="parameter"><code>date_style</code></em>
is set to custom</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-humanize-file-time.returns"></a><h4>Returns</h4>
<p> a human readable date representation of <em class="parameter"><code>file_time</code></em>
according to the <em class="parameter"><code>date_format</code></em>
.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-parse-parent"></a><h3>thunar_util_parse_parent ()</h3>
<pre class="programlisting"><span class="returnvalue">GdkScreen</span> *
thunar_util_parse_parent (<em class="parameter"><code><span class="type">gpointer</span> parent</code></em>,
                          <em class="parameter"><code><span class="type">GtkWindow</span> **window_return</code></em>);</pre>
<p>Determines the screen for the <em class="parameter"><code>parent</code></em>
 and returns that <span class="type">GdkScreen</span>.
If <em class="parameter"><code>window_return</code></em>
 is not <code class="literal">NULL</code>, the pointer to the <span class="type">GtkWindow</span> is
placed into it, or <code class="literal">NULL</code> if the window could not be determined.</p>
<div class="refsect3">
<a name="thunar-util-parse-parent.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>parent</p></td>
<td class="parameter_description"><p>a <span class="type">GtkWidget</span>, a <span class="type">GdkScreen</span> or <code class="literal">NULL</code>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>window_return</p></td>
<td class="parameter_description"><p>return location for the toplevel <span class="type">GtkWindow</span> or
<code class="literal">NULL</code>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-parse-parent.returns"></a><h4>Returns</h4>
<p> the <span class="type">GdkScreen</span> for the <em class="parameter"><code>parent</code></em>
.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-time-from-rfc3339"></a><h3>thunar_util_time_from_rfc3339 ()</h3>
<pre class="programlisting"><span class="returnvalue">time_t</span>
thunar_util_time_from_rfc3339 (<em class="parameter"><code>const <span class="type">gchar</span> *date_string</code></em>);</pre>
<p>Decodes the <em class="parameter"><code>date_string</code></em>
, which must be in the special RFC 3339
format <code class="literal">YYYY-MM-DDThh:mm:ss</code>. This method is
used to decode deletion dates of files in the trash. See the
Trash Specification for details.</p>
<div class="refsect3">
<a name="thunar-util-time-from-rfc3339.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>date_string</p></td>
<td class="parameter_description"><p>an RFC 3339 encoded date string.</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-time-from-rfc3339.returns"></a><h4>Returns</h4>
<p> the time value matching the <em class="parameter"><code>date_string</code></em>
or
<code class="literal">0</code> if the <em class="parameter"><code>date_string</code></em>
could not be parsed.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-change-working-directory"></a><h3>thunar_util_change_working_directory ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_change_working_directory (<em class="parameter"><code>const <span class="type">gchar</span> *new_directory</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-setup-display-cb"></a><h3>thunar_setup_display_cb ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
thunar_setup_display_cb (<em class="parameter"><code><span class="type">gpointer</span> data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-next-new-file-name"></a><h3>thunar_util_next_new_file_name ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_next_new_file_name (<em class="parameter"><code><a class="link" href="ThunarFile.html" title="ThunarFile"><span class="type">ThunarFile</span></a> *dir</code></em>,
                                <em class="parameter"><code>const <span class="type">gchar</span> *file_name</code></em>,
                                <em class="parameter"><code><a class="link" href="thunar-thunar-util.html#ThunarNextFileNameMode" title="enum ThunarNextFileNameMode"><span class="type">ThunarNextFileNameMode</span></a> name_mode</code></em>,
                                <em class="parameter"><code><span class="type">gboolean</span> is_directory</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-next-new-file-name-raw"></a><h3>thunar_util_next_new_file_name_raw ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_next_new_file_name_raw (<em class="parameter"><code><span class="type">GList</span> *file_list</code></em>,
                                    <em class="parameter"><code>const <span class="type">gchar</span> *file_name</code></em>,
                                    <em class="parameter"><code><a class="link" href="thunar-thunar-util.html#ThunarNextFileNameMode" title="enum ThunarNextFileNameMode"><span class="type">ThunarNextFileNameMode</span></a> name_mode</code></em>,
                                    <em class="parameter"><code><span class="type">gboolean</span> is_directory</code></em>);</pre>
<p>Returns a filename that is like <em class="parameter"><code>file_name</code></em>
 with the possible addition of
a number to differentiate it from other similarly named files. In other words
it searches <em class="parameter"><code>dir</code></em>
 for incrementally named files starting from <em class="parameter"><code>file_name</code></em>

and returns the first available increment.</p>
<p>e.g. in a folder with the following files:</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>file</p></li>
<li class="listitem"><p>empty</p></li>
<li class="listitem"><p>file_copy</p></li>
</ul></div>
<p>Calling this functions with the above folder and <em class="parameter"><code>file_name</code></em>
 equal to 'file' the returned
filename will be 'file 1' for the mode "new file".</p>
<p>The caller is responsible to free the returned string using <code class="function">g_free()</code> when no longer needed.</p>
<div class="refsect3">
<a name="thunar-util-next-new-file-name-raw.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>file_name</p></td>
<td class="parameter_description"><p>the filename which will be used as the basis/default</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>ThunarNextFileNameMode</p></td>
<td class="parameter_description"><p>To decide if the naming should follow "file copy","file link" or "new file" syntax</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>is_directory</p></td>
<td class="parameter_description"><p>TRUE, if <em class="parameter"><code>file_name</code></em>
is supposed to be the name of a directory</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-next-new-file-name-raw.returns"></a><h4>Returns</h4>
<p> pointer to the new filename.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-get-search-prefix"></a><h3>thunar_util_get_search_prefix ()</h3>
<pre class="programlisting">const <span class="returnvalue">char</span> *
thunar_util_get_search_prefix (<em class="parameter"><code><span class="type">void</span></code></em>);</pre>
<div class="refsect3">
<a name="thunar-util-get-search-prefix.returns"></a><h4>Returns</h4>
<p> The localized search prefix</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-is-a-search-query"></a><h3>thunar_util_is_a_search_query ()</h3>
<pre class="programlisting"><span class="returnvalue">gboolean</span>
thunar_util_is_a_search_query (<em class="parameter"><code>const <span class="type">gchar</span> *string</code></em>);</pre>
<div class="refsect3">
<a name="thunar-util-is-a-search-query.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody><tr>
<td class="parameter_name"><p>string</p></td>
<td class="parameter_description"><p>the string to check</p></td>
<td class="parameter_annotations"> </td>
</tr></tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-is-a-search-query.returns"></a><h4>Returns</h4>
<p> a boolean that is TRUE if <em class="parameter"><code>string</code></em>
starts with 'Search: '.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-strjoin-list"></a><h3>thunar_util_strjoin_list ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_strjoin_list (<em class="parameter"><code><span class="type">GList</span> *string_list</code></em>,
                          <em class="parameter"><code>const <span class="type">gchar</span> *separator</code></em>);</pre>
<p>Joins a number of strings together to form one long string, with the optional separator
inserted between each of them. It skips all the NULL values passed in the list. The returned
string should be freed with <code class="function">g_free()</code>.
Similar to <code class="function">g_strjoin()</code>.</p>
<p>The caller is responsible to free the returned text using <code class="function">g_free()</code> when it is no longer needed</p>
<div class="refsect3">
<a name="thunar-util-strjoin-list.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>data</p></td>
<td class="parameter_description"><p>list of strings which needs to be appended.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>separator</p></td>
<td class="parameter_description"><p>text which needs to be added as a seperator</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-strjoin-list.returns"></a><h4>Returns</h4>
<p> the concatenated string</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-clip-view-background"></a><h3>thunar_util_clip_view_background ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>
thunar_util_clip_view_background (<em class="parameter"><code><span class="type">GtkCellRenderer</span> *cell</code></em>,
                                  <em class="parameter"><code><span class="type">cairo_t</span> *cr</code></em>,
                                  <em class="parameter"><code>const <span class="type">GdkRectangle</span> *background_area</code></em>,
                                  <em class="parameter"><code><span class="type">GtkWidget</span> *widget</code></em>,
                                  <em class="parameter"><code><span class="type">GtkCellRendererState</span> flags</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-split-search-query"></a><h3>thunar_util_split_search_query ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> **
thunar_util_split_search_query (<em class="parameter"><code>const <span class="type">gchar</span> *search_query_normalized</code></em>,
                                <em class="parameter"><code><span class="type">GError</span> **error</code></em>);</pre>
<p>Search terms are split on whitespace. Search queries must be
normalized before passing to this function.</p>
<p>See also: <a class="link" href="thunar-thunar-gobject-extensions.html#thunar-g-utf8-normalize-for-search" title="thunar_g_utf8_normalize_for_search ()"><code class="function">thunar_g_utf8_normalize_for_search()</code></a>.</p>
<div class="refsect3">
<a name="thunar-util-split-search-query.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>search_query</p></td>
<td class="parameter_description"><p>The search query to split.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>error</p></td>
<td class="parameter_description"><p>Return location for regex compilation errors.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-split-search-query.returns"></a><h4>Returns</h4>
<p> a list of search terms which must be freed with <code class="function">g_strfreev()</code></p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-search-terms-match"></a><h3>thunar_util_search_terms_match ()</h3>
<pre class="programlisting"><span class="returnvalue">gboolean</span>
thunar_util_search_terms_match (<em class="parameter"><code><span class="type">gchar</span> **terms</code></em>,
                                <em class="parameter"><code><span class="type">gchar</span> *str</code></em>);</pre>
<p>All search terms must match. Thunar uses simple substring matching
for the broadest multilingual support. <em class="parameter"><code>str</code></em>
 must be normalized before
passing to this function.</p>
<p>See also: <a class="link" href="thunar-thunar-gobject-extensions.html#thunar-g-utf8-normalize-for-search" title="thunar_g_utf8_normalize_for_search ()"><code class="function">thunar_g_utf8_normalize_for_search()</code></a>.</p>
<div class="refsect3">
<a name="thunar-util-search-terms-match.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>terms</p></td>
<td class="parameter_description"><p>The search terms to look for, prepared with <a class="link" href="thunar-thunar-util.html#thunar-util-split-search-query" title="thunar_util_split_search_query ()"><code class="function">thunar_util_split_search_query()</code></a>.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>str</p></td>
<td class="parameter_description"><p>The string which the search terms might be found in.</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-search-terms-match.returns"></a><h4>Returns</h4>
<p> TRUE if all terms matched, FALSE otherwise.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-save-geometry-timer"></a><h3>thunar_util_save_geometry_timer ()</h3>
<pre class="programlisting"><span class="returnvalue">gboolean</span>
thunar_util_save_geometry_timer (<em class="parameter"><code><span class="type">gpointer</span> user_data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-get-statusbar-text-for-files"></a><h3>thunar_util_get_statusbar_text_for_files ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_get_statusbar_text_for_files
                               (<em class="parameter"><code><span class="type">GHashTable</span> *files</code></em>,
                                <em class="parameter"><code><span class="type">gboolean</span> show_hidden</code></em>,
                                <em class="parameter"><code><span class="type">gboolean</span> show_file_size_binary_format</code></em>,
                                <em class="parameter"><code><a class="link" href="thunar-thunar-enum-types.html#ThunarDateStyle" title="enum ThunarDateStyle"><span class="type">ThunarDateStyle</span></a> date_style</code></em>,
                                <em class="parameter"><code>const <span class="type">gchar</span> *date_custom_style</code></em>,
                                <em class="parameter"><code><span class="type">guint</span> status_bar_actve_info</code></em>);</pre>
<p>Generates the statusbar text for the given <em class="parameter"><code>files</code></em>
.</p>
<p>The caller is reponsible to free the returned text using
<code class="function">g_free()</code> when it's no longer needed.</p>
<div class="refsect3">
<a name="thunar-util-get-statusbar-text-for-files.parameters"></a><h4>Parameters</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="150px" class="parameters_name">
<col class="parameters_description">
<col width="200px" class="parameters_annotations">
</colgroup>
<tbody>
<tr>
<td class="parameter_name"><p>files</p></td>
<td class="parameter_description"><p>list of <span class="type">GFile</span>'s for which a text is requested</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>show_hidden</p></td>
<td class="parameter_description"><p>whether hidden files are shown</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>show_file_size_binary_format</p></td>
<td class="parameter_description"><p>whether the file size should be displayed in binary format</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>date_style</p></td>
<td class="parameter_description"><p>the <span class="type">ThunarDateFormat</span> used to humanize the <em class="parameter"><code>file_time</code></em>
.</p></td>
<td class="parameter_annotations"> </td>
</tr>
<tr>
<td class="parameter_name"><p>date_custom_style</p></td>
<td class="parameter_description"><p>custom style to apply, if <em class="parameter"><code>date_style</code></em>
is set to custom</p></td>
<td class="parameter_annotations"> </td>
</tr>
</tbody>
</table></div>
</div>
<div class="refsect3">
<a name="thunar-util-get-statusbar-text-for-files.returns"></a><h4>Returns</h4>
<p> the statusbar text with the given <em class="parameter"><code>files</code></em>
.</p>
</div>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-get-statusbar-text-for-single-file"></a><h3>thunar_util_get_statusbar_text_for_single_file ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_get_statusbar_text_for_single_file
                               (<em class="parameter"><code><a class="link" href="ThunarFile.html" title="ThunarFile"><span class="type">ThunarFile</span></a> *file</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="thunar-util-accel-path-to-id"></a><h3>thunar_util_accel_path_to_id ()</h3>
<pre class="programlisting"><span class="returnvalue">gchar</span> *
thunar_util_accel_path_to_id (<em class="parameter"><code>const <span class="type">gchar</span> *accel_path</code></em>);</pre>
</div>
</div>
<div class="refsect1">
<a name="thunar-thunar-util.other_details"></a><h2>Types and Values</h2>
<div class="refsect2">
<a name="ALPHA-BACKDROP:CAPS"></a><h3>ALPHA_BACKDROP</h3>
<pre class="programlisting">#define ALPHA_BACKDROP 0.5
</pre>
</div>
<hr>
<div class="refsect2">
<a name="ALPHA-FOCUSED:CAPS"></a><h3>ALPHA_FOCUSED</h3>
<pre class="programlisting">#define ALPHA_FOCUSED 1.0
</pre>
</div>
<hr>
<div class="refsect2">
<a name="STACK-ALLOC-LIMIT:CAPS"></a><h3>STACK_ALLOC_LIMIT</h3>
<pre class="programlisting">#define STACK_ALLOC_LIMIT 2000
</pre>
</div>
<hr>
<div class="refsect2">
<a name="MAX-EMBLEMS-PER-FILE:CAPS"></a><h3>MAX_EMBLEMS_PER_FILE</h3>
<pre class="programlisting">#define MAX_EMBLEMS_PER_FILE 4
</pre>
</div>
<hr>
<div class="refsect2">
<a name="ThunarNextFileNameMode"></a><h3>enum ThunarNextFileNameMode</h3>
<div class="refsect3">
<a name="ThunarNextFileNameMode.members"></a><h4>Members</h4>
<div class="informaltable"><table class="informaltable" width="100%" border="0">
<colgroup>
<col width="300px" class="enum_members_name">
<col class="enum_members_description">
<col width="200px" class="enum_members_annotations">
</colgroup>
<tbody>
<tr>
<td class="enum_member_name"><p><a name="THUNAR-NEXT-FILE-NAME-MODE-NEW:CAPS"></a>THUNAR_NEXT_FILE_NAME_MODE_NEW</p></td>
<td> </td>
<td> </td>
</tr>
<tr>
<td class="enum_member_name"><p><a name="THUNAR-NEXT-FILE-NAME-MODE-COPY:CAPS"></a>THUNAR_NEXT_FILE_NAME_MODE_COPY</p></td>
<td> </td>
<td> </td>
</tr>
<tr>
<td class="enum_member_name"><p><a name="THUNAR-NEXT-FILE-NAME-MODE-LINK:CAPS"></a>THUNAR_NEXT_FILE_NAME_MODE_LINK</p></td>
<td> </td>
<td> </td>
</tr>
</tbody>
</table></div>
</div>
</div>
</div>
</div>
<div class="footer">
<hr>Generated by GTK-Doc V1.34.0</div>
</body>
</html>